﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace aFrameEdit
{
    public partial class EffectToneSaveAsForm : Form
    {
        private int selectToneIndex;

        public EffectToneSaveAsForm(ProjectToneNameList nameList, int effectNum)
        {
            InitializeComponent();
            selectToneIndex = effectNum;
            foreach (string name in nameList.effectNames)
            {
                effectSaveAscomboBox.Items.Add(name);
            }
            effectSaveAscomboBox.Text = nameList.effectNames[selectToneIndex];
        }

        private void effectSaveAsSavebutton_Click(object sender, EventArgs e)
        {
            string effectNumAndName = effectSaveAscomboBox.Text;
            MainForm parent = (MainForm)this.Owner;
            string effectName;

            string[] nameStrings = effectNumAndName.Split(':');
            if (nameStrings.Length == 1) // empty, name only
            {
                if (effectNumAndName.Length > 12)
                {
                    MessageBox.Show("Name length is longger.\nInput within 12 characters.");
                    return;
                }
                effectName = nameStrings[0];
                effectNumAndName = "E" + (selectToneIndex + 1).ToString("00") + ":" + nameStrings[0];
            }
            else
            {
                if (effectNumAndName.Length > 16)
                {
                    MessageBox.Show("Name length is longger.\nInput within 16 characters include tone number.");
                    return;
                }
                effectName = "";
                for (int i = 1; i < nameStrings.Length - 1; i++)
                {
                    effectName += nameStrings[i] + ":";
                }
                effectName += nameStrings[nameStrings.Length - 1];
            }

            parent.currentToneInfo.toneName.effectName = effectNumAndName;
            parent.currentToneData.effectToneData.name = effectName;
            parent.prjToneNameList.effectNames[selectToneIndex] = effectNumAndName;
            parent.changeEditBuffName(1, effectName);

            parent.writeEditBuffToProject(1, selectToneIndex);
            parent.isToneEffectEdited = false;
            parent.copyProjectToneNameList();
            parent.copyCurrentToneData();
            if (selectToneIndex != parent.currentToneInfo.effectNum)
            {
                parent.changeToneNum(1, selectToneIndex);
                parent.isTonePairChanged = true;
                parent.setToneNameColor();
                parent.enableGroupOriginalAndSaveButton();
            }
            parent.currentToneInfo.effectNum = selectToneIndex;
            parent.setComboBoxEffectNameItems();
            parent.setComboBoxEffectName(effectNumAndName);
            parent.disableEffectOriginalAndSaveButton();
            parent.enableComboBoxEffectName();
            parent.setEffectNameLabelWhite();
            parent.clearEffectChangedInfo();
            this.Dispose();
        }

        private void effectSaveAscomboBox_SelectionChangeCommitted(object sender, EventArgs e)
        {
            selectToneIndex = ((ComboBox)sender).SelectedIndex;
        }
    }
}
